include 'Vram.inc'
include 'Chars.inc'

ext WRTVRM, RDVRM, LDIRVM, FILVRM
ext MonoPattern, SpritePattern

cseg
ColorSource:
	defb 64, 0f0h ; Ascii
	defb 16, 70h ; Logo
	defb 8, 70h ; CrackedFloor
	defb 1, 70h ; HardFloor
	defb 2, 0e0h ; Ladder
	defb 4, 0b0h ; Item
	defb 4, 0f0h ; Remain
    defb 0

; void InitVram();
VdpValues:
    defb 02h, 0e2h
    defb 06h,0ffh,03h,36h,07h,00h
cseg
InitVram_: public InitVram_
    push af | push hl | push de | push bc
        ld hl,VdpValues
        ld c,0
        ld b,8
        do
            ld a,(hl) | out (VdpPort+1),a
            inc hl
            ld a,c | or 80h | out (VdpPort+1),a
            inc c
        dwnz

        ld hl,MonoPattern
        ld de,Vram_PatternGenerator
        ld bc,Char_End*CharHeight
        call LDIRVM

        ld hl,Vram_Color
        ld de,ColorSource
        do
            ld a,(de)
            or a
        while nz
            ld c,a
            inc de
            ld a,(de)
            inc de
            do
                ld b,8
                do
                    push af
                        call WRTVRM
                    pop af
                    inc hl
                dwnz
                dec c
            while nz | wend
        wend

        ld hl,Vram_PatternGenerator+800h
        exx
            ld hl,Vram_PatternGenerator
        exx
        ld c,2
        do
            ld b,2
            do
                ld de,800h
                do
                    exx
                        call RDVRM
                        inc hl
                    exx
                    call WRTVRM
                    inc hl
                    dec de
                    ld a,e
                    or d
                while nz | wend
            dwnz
            ld hl,Vram_Color+800h
            exx
                ld hl,Vram_Color
            exx
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void ClearScreen();
cseg
ClearScreen_:
    public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram_PatternName
        ld bc,VramHeight*VramWidth
        xor a
        call FILVRM

        ld hl,Vram_SpriteAttribute
        ld bc,4*32
        ld a,0d0h
        call FILVRM
    pop bc | pop hl | pop af
ret


; word VramAddress(byte x, byte y);
VramAddress_: public VramAddress_
    push de
        ld l,e
        ld h,0
        add hl,hl ;*2
        add hl,hl ;*4
        add hl,hl ;*8
        add hl,hl ;*16
        add hl,hl ;*32
        ld e,a
        ld d,0
        add hl,de
        ld de,Vram
        add hl,de
    pop de
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
    ex af,af'
        ld a,e
        call WRTVRM
        inc hl
    ex af,af'
ret


; word PrintC(word vram, byte c);
cseg
PrintC_: public PrintC_
    ex af,af'
        ld a,e
        sub ' '
        call WRTVRM
    ex af,af'
    inc hl
ret
